function rate = calcOR(bb, Z, opts)
    bb1 = affine2centerdim(bb', opts);
    bb2 = affine2centerdim(Z, opts);
    vertex1 = [bb1(1, :) - bb1(3, :) / 2; bb1(1, :) + bb1(3, :) / 2; bb1(2, :) - bb1(4, :) / 2; bb1(2, :) + bb1(4, :) / 2];
    vertex2 = [bb2(1, :) - bb2(3, :) / 2; bb2(1, :) + bb2(3, :) / 2; bb2(2, :) - bb2(4, :) / 2; bb2(2, :) + bb2(4, :) / 2];
    minX = max(vertex1(1, :), vertex2(1, :));
    maxX = min(vertex1(2, :), vertex2(2, :));
    minY = max(vertex1(3, :), vertex2(3, :));
    maxY = min(vertex1(4, :), vertex2(4, :));
    overlapping = max(0, maxX - minX) .* max(0, maxY - minY);
    rate = overlapping ./ (bb1(3, :) .* bb1(4, :) + bb2(3, :) .* bb2(4, :) - overlapping);
end