#include "mexutils.h"

#include <cmath>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;
#define IN_WEIGHT prhs[0]
#define OUT_IDX plhs[0]

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray*prhs[]){
    double* weight = mxGetPr(IN_WEIGHT);
    
    int n = mxGetN(IN_WEIGHT);
    int m = mxGetM(IN_WEIGHT); 
    //mexPrintf("m = %d, n = %d\n", m, n);
    OUT_IDX = mxCreateDoubleMatrix(m, n, mxREAL);
    double *out = mxGetPr(OUT_IDX);
    
    vector<double> cumsum(n);
    cumsum[0] = weight[0];
    for (int i = 1; i < n; ++i){
        cumsum[i] = cumsum[i - 1] + weight[i];
    }
    cumsum[n - 1] = 1;
    vector<double> r(n);
    for (int i = 0; i < n; ++i){
        r[i] = rand() / (double)RAND_MAX;
    }
    sort(r.begin(), r.end());
    int pos = 0;
    for (int i = 0; i < n; ++i){
        while (r[pos] <= cumsum[i] && pos < n){
            //mexPrintf("%lf %lf\n", r[pos], cumsum[i]);
            out[pos++] = i + 1;
        }
    }

}