%%DUT-IIAU-DongWang-2013-03-27
%%Dong Wang, Huchuan Lu, Minghsuan Yang, Least Soft-thresold Squares
%%Tracking. CVPR 2013.
%%http://ice.dlut.edu.cn/lu/index.html
%%wangdong.ice@gmail.com
%%
% script: trackparam.m
%     loads data and initializes variables
%
% We would like to thank Jongwoo Lim and David Ross for sharing their codes
% and descriptions. 

% DESCRIPTION OF OPTIONS:
%
% Following is a description of the options you can adjust for
% tracking, each proceeded by its default value.

%*************************************************************
% For a new sequence , you will certainly have to change p.
%       һµƵУҪıpֵ
%*************************************************************
%
% To set the other options,
% first try using the values given for one of the demonstration
% sequences, and change parameters as necessary.
%
%*************************************************************
% p = [px, py, sx, sy, theta]; 
% The location of the target in the first frame.
%       Ŀڵһ֡λ
% px and py are th coordinates of the centre of the box
%   pxpy          Ŀλã
%
% sx and sy are the size of the box in the x (width) and y (height)
%   dimensions, before rotation
%   sxsy          ĿĿ
%
% theta is the rotation angle of the box
%   theta           ĿתǶ
%
% 'numsample',400,   The number of samples used in the condensation
% algorithm/particle filter.  Increasing this will likely improve the
% results, but make the tracker slower.
%   'numsample'  :    ӻЧٶȻ
%
% 'condenssig',0.01,  The standard deviation of the observation likelihood.
%   'condenssig     ۲Ȼ׼ƫ
%
% 'ff',1, The forgetting factor, as described in the paper.  When
% doing the incremental update, 1 means remember all past data, and 0
% means remeber none of it.
%   'ff'            
%
% 'batchsize',5, How often to update the eigenbasis.  We've used this
% value (update every 5th frame) fairly consistently, so it most
% likely won't need to be changed.  A smaller batchsize means more
% frequent updates, making it quicker to model changes in appearance,
% but also a little more prone to drift, and require more computation.
%   'batchsize'     ¼
%
% 'affsig',[4,4,.02,.02,.005,.001]  These are the standard deviations of
% the dynamics distribution, that is how much we expect the target
% object might move from one frame to the next.  The meaning of each
% number is as follows:
%   'affsig'       ̬ģͣaffine任ֲ"ֵ",""
%    affsig(1) = x translation (pixels, mean is 0)
%    affsig(2) = y translation (pixels, mean is 0)
%    affsig(3) = rotation angle (radians, mean is 0)
%    affsig(4) = x scaling (pixels, mean is 1)
%    affsig(5) = y scaling (pixels, mean is 1)
%    affsig(6) = scaling angle (radians, mean is 0)
%
% OTHER OPTIONS THAT COULD BE SET HERE:
%
% 'tmplsize', [32,32] The resolution at which the tracking window is
% sampled, in this case 32 pixels by 32 pixels.  If your initial
% window (given by p) is very large you may need to increase this.
%   'tmplsize'     ٴС
%
% 'maxbasis', 16 The number of basis vectors to keep in the learned
% apperance model.
%   'maxbasis'  :   
%

%%******Change 'title' to choose the sequence you wish to run******%%
condenssig = 0.05;
switch (title) 
%%-------------------------------------------------------------------------
    case 'woman';  p = [222 165 35 95 0.0];
    opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5,'affsig',[4,4,.005,.000,.001,.000]);        
    
    case 'Caviar3'; 
        p = [162 216 50 140 0.0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4, 4,.01,.00,.00,.00]);
    %
    case 'Caviar1'; 
        p = [145,112,30,79,0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4,4,.01,.00,.00,.00]);
    %  
    case 'Caviar2';   
        p = [ 152, 68, 18, 61, 0.00 ];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4,4,.01,.00,.00,.00]); 
    %
    case 'Occlusion1'; 
        p = [177,147,115,145,0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4, 4,.01,.00,.00,.00]);  
    %             
    case 'Occlusion2';    
        p = [156,107,74,100,0.00];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4, 4,.008,.012,.00,.00]);               
    %
    case 'Deer';  
        p = [350, 40, 100, 70, 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[12,12,.01,.00,.00,.00]);
    %
    case 'Jumping';         
        p = [163,126,33,32,0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[12,12,.01,.00,.00,.00]);                      
    %
    case 'DavidIndoorOld';  
        p = [160 112 60 92 -0.02];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4, 4,.005,.02,.00,.00]);  
    %
    case 'DavidIndoorNew'; 
        p = [194,108,46,60,0.00];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4, 4,.002,.01,.00,.00]);
    %
    case 'Car11';  
        p = [89 140 30 25 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[4, 4,.01,.00,.00,.00]);  
    %
    case 'Owl';      
        p = [380 247 56 100 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[25,25,.01,.00,.00,.00]); 
    %
    case 'Face';  
        p = [293 283 94 114 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1.0,...
                     'batchsize',5, 'affsig',[25,25,.01,.00,.00,.00]);  
    %
    case 'Singer1';  
        p = [100, 200, 100, 300, 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1,...
                     'batchsize', 5, 'affsig',[4,4,.01,.00,.00,.00]); 
    %
    case 'car4'; 
         p = [123 94 107 87 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1,...
                     'batchsize',5, 'affsig',[4,4,.01,.00,.00,.00]); 
    %
    case 'Football'; 
        p = [330 125 50 50 0];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1,...
                     'batchsize',5, 'affsig',[4,4,.005,.00,.00,.00]);  
    %
    case 'DavidOutdoor'; 
        p = [102,266,40,134,0.00];
        opt = struct('numsample',600, 'condenssig',condenssig, 'ff',1,...
                     'batchsize',5, 'affsig',[6,6,.00,.00,.00,.00]);    
    case 'shaking';  p = [250 170 60 70 0];% 0.8
        opt = struct('numsample',400, 'condenssig',condenssig, 'ff',1,...
                     'batchsize',5, 'affsig',[4,4,.005,.00,.001,.00]);
    case 'davidin';  p = [158 106 62 78 0]; %0.9
    opt = struct('numsample',600, 'condenssig',condenssig, 'ff',0.98,...
                    'batchsize',5,'affsig',[4, 4,.005,.00,.001,.00]);
    
    otherwise;  error(['unknown title ' title]);
end
%%******Change 'title' to choose the sequence you wish to run******%%

%%***************************Data Path*****************************%%
dataPath = [ '..\..\data\' title '\'];
%%***************************Data Path*****************************%%