methods = {'Struck', 'CSK', 'ASLA', 'DLT',  'LSST'};
seqs = configSeqs;


for seq = seqs
    Z = cell(seq{1}.endFrame - seq{1}.startFrame + 1, 1);
    name = seq{1}.name
    for i = 1 : size(methods, 2)
        load([name '_' methods{i}]); 
        if strcmp(results{1}.type, 'rect')
            for j = 1 : results{1}.len
                r = results{1}.res(j, :);
                r = [r(1) + r(3) / 2, r(2) + r(4) / 2, r(3), r(4)];
                temp = [r(1), r(2), r(3)/32, 0, r(4) /r(3), 0];
                Z{j}(:, i) = (temp);
            end
        elseif strcmp(results{1}.type, 'ivtAff')
            for j = 1 : results{1}.len
                r = results{1}.res(j, :);
                r(isnan(r)) = 0;
                try
                    Z{j}(:, i) = affparam2geom(r);
                catch
                    disp(1);
                end
            end
        end
    end
    
    % Generate the baseline
    res = [];
    for i = 1 : seq{1}.endFrame - seq{1}.startFrame + 1
        temp = zeros(4, 1);
        cum = zeros(4, 1);
        for j = 1 : size(methods, 2)
            try
            temp(1) = Z{i}(1, j);
            temp(2) = Z{i}(2, j);
            temp(3) = Z{i}(3, j) * 32;
            temp(4) = Z{i}(5, j) * Z{i}(3, j) * 32;
            temp(1) = temp(1) - temp(3) / 2;
            temp(2) = temp(2) - temp(4) / 2;
            cum = cum + temp;
            catch
                disp(1);
            end
        end
        res = [res cum / size(methods, 2)];
    end

    results{1}.res=res';
    results{1}.type='rect';
    results{1}.tmplsize = [32 32];
    results{1}.fps = 5;
    save(['data/' name '.mat'], 'Z');
%     save(['data/' name '_baseline.mat'], 'results');
end